/**
	$Id $

	Copyright (C) 2014 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.login;

/**
	A simple implementation of the {@link LoginFormAction} interface.
	
	@author Nicklas
	@since 3.3
*/
public class LoginFormBean 
	implements LoginFormAction
{
	
	private String help;
	private FieldInfo loginField;
	private FieldInfo passwordField;
	private boolean rememberLastLogin;

	public LoginFormBean()
	{}
	
	@Override
	public String getHelp()
	{
		return help;
	}
	
	public void setHelp(String help)
	{
		this.help = help;
	}
	
	@Override
	public FieldInfo getLoginField()
	{
		return loginField;
	}
	
	public void setLoginField(FieldInfo loginField)
	{
		this.loginField = loginField;
	}

	@Override
	public FieldInfo getPasswordField() 
	{
		return passwordField;
	}
	
	public void setPasswordField(FieldInfo passwordField)
	{
		this.passwordField = passwordField;
	}

	@Override
	public boolean rememberLastLogin()
	{
		return rememberLastLogin;
	}
	
	public void setRememberLastLogin(boolean remember)
	{
		this.rememberLastLogin = remember;
	}

}
