/**
	$Id$

	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.extensions.section;

/**
	A simple bean-like implementation of the SectionAction 
	interface.

	@author Nicklas
	@since 3.2
	@base.modified $Date$
*/
public class SectionBean
	implements SectionAction
{

	private String id;
	private String showClazz;
	private String hideClazz;
	private String style;
	private String contentStyle;
	private String title;
	private String content;

	public SectionBean()
	{}
	
	/*
		From the SectionAction interface
		--------------------------------
	*/
	@Override
	public String getId()
	{
		return id;
	}

	@Override
	public String getShowClazz()
	{
		return showClazz;
	}

	@Override
	public String getHideClazz()
	{
		return hideClazz;
	}

	@Override
	public String getStyle()
	{
		return style;
	}

	@Override
	public String getContentStyle()
	{
		return contentStyle;
	}

	@Override
	public String getTitle()
	{
		return title;
	}

	@Override
	public String getContent()
	{
		return content;
	}
	// --------------------------
	public void setId(String id) 
	{
		this.id = id;
	}

	public void setShowClazz(String showClazz) 
	{
		this.showClazz = showClazz;
	}

	public void setHideClazz(String hideClazz) 
	{
		this.hideClazz = hideClazz;
	}

	public void setStyle(String style) 
	{
		this.style = style;
	}

	public void setContentStyle(String contentStyle) 
	{
		this.contentStyle = contentStyle;
	}
	
	public void setTitle(String title) 
	{
		this.title = title;
	}

	public void setContent(String content)
	{
		this.content = content;
	}
}
