/**
	$Id$

	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.clients.web.plugins;

import net.sf.basedb.core.BioMaterialEvent;
import net.sf.basedb.core.BioMaterialEventSource;
import net.sf.basedb.core.DbControl;
import net.sf.basedb.core.Directory;
import net.sf.basedb.core.File;
import net.sf.basedb.core.Nameable;
import net.sf.basedb.core.Path;
import net.sf.basedb.core.SpecialQuery;

/**	
	This is a loader implementation that load the path of a file or directory.
	
	@author Nicklas
	@since 3.4
	@base.modified $Date$
*/

public class PathLoader 
	implements DataLoader<Nameable>
{

	private final SpecialQuery<BioMaterialEventSource> query;
	
	public PathLoader()
	{
		this.query = BioMaterialEventSource.getQuery((BioMaterialEvent)null);
	}
	
	@Override
	public Object getData(DbControl dc, ExportedProperty exportedProperty, Nameable item) 
		throws Exception
	{
		Path path = null;
		if (item instanceof File)
		{
			path = ((File)item).getPath().getParent();
		}
		else if (item instanceof Directory)
		{
			path = ((Directory)item).getPath().getParent();
		}
		return path == null ? null : path.toString();
	}

}
