/*
	$Id: BatchableData.java 5818 2011-10-21 11:15:41Z nicklas $

	Copyright (C) 2005 Samuel Andersson, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

/**
	This is a tagging interface only.
	Data classes that want to have batch functionality must
	implement this interface, plus that a subclass of the 
	abstract <code>BasicBatcher</code> class in the core must be created.
	
	@author Samuel
	@version 2.0
	@see net.sf.basedb.core.BasicBatcher
	@see <a href="../../../../../../html/developer/api/data_api.basic.html">Developer documentation: Basic classes and interfaces</a>
	@see <a href="../../../../../../html/developer/api/core_api.batch.html">Developer documentation: Batch operations</a>
*/
public interface BatchableData
	extends IdentifiableData
{}
