/*
	$Id: UserGroups.java 6127 2012-09-14 07:28:35Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data.keyring;
import java.io.Serializable;

/**
	Class for mapping the <code>UserGroups</code> table.
	@author Nicklas
	@version 2.0
	@base.modified $Date: 2012-09-14 09:28:35 +0200 (fr, 14 sep 2012) $
*/
public final class UserGroups
	implements Serializable
{

	/**
		
	*/
	private static final long serialVersionUID = -3481737087412081175L;
	private int userId;
	private int groupId;
	
	/**
		Create a new <code>UserGroups</code> object.
	*/
	public UserGroups()
	{}

	/**
		Get the id of the user.
	*/
	public int getUserId()
	{
		return userId;
	}
	/**
		Set the id of the user.
	*/
	public void setUserId(int userId)
	{
		this.userId = userId;
	}
	/**
		Get the id of the group.
	*/
	public int getGroupId()
	{
		return groupId;
	}
	/**
		Set the id of the group.
	*/
	public void setGroupId(int groupId)
	{
		this.groupId = groupId;
	}

	/**
		Check if this object is equal to another <code>UserGroups</code>
		object. They are considered to be the same if the user id and the
		group id are the same.
	*/
	@Override
	public boolean equals(Object o)
	{
		if ((o == null) || (getClass() != o.getClass())) return false;
		UserGroups ug = (UserGroups)o;
		return (ug.userId == this.userId && ug.groupId == this.groupId);
	}
	
	/**
		Calculate the hash code for the object.
	*/
	@Override
	public int hashCode()
	{
		return (int)(31*userId + 17*groupId);
	}
}
