/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/
var Options = function()
{
	var options = {};
	
	options.initPage = function()
	{
		Buttons.addClickHandler('close', App.closeWindow);
		Buttons.addClickHandler('btnSave', options.save);
		
		Events.addEventHandler('presets', 'change', options.presetOnChange);
		Buttons.addClickHandler('btnSaveAsPreset', options.saveAsPresetOnClick);
		Buttons.addClickHandler('btnRemovePreset', options.removePresetOnClick);
	}
	
	options.initGroup = function(element, autoInit)
	{
		if (autoInit == 'group-toggle')
		{
			Events.addEventHandler(element, 'click', options.toggleGroup);
		}
		else if (autoInit == 'group-severity')
		{
			Events.addEventHandler(element, 'change', options.setGroupSeverity);
		}
	}

	options.save = function()
	{
		document.forms['options'].submit();
	}
	
	options.presetOnChange = function()
	{
		var frm = document.forms['options'];
		var selected = frm.presets.value;
		if (selected == '')
		{
			location.href = 'options.jsp?ID='+App.getSessionId()+'&resetToDefault=1';
		}
		else if (selected != '---')
		{
			location.href = 'options.jsp?ID='+App.getSessionId()+'&presetName='+encodeURIComponent(selected);
		}
	}

	options.saveAsPresetOnClick = function()
	{
		Dialogs.openPopup('save_preset.jsp?ID='+App.getSessionId(), 'SaveValidationPreset', 450, 300);
	}
	
	options.saveAsPreset = function(name)
	{
		var frm = document.forms['options'];
		frm.cmd.value = 'SaveAsPreset';
		Forms.addHidden(frm, 'presetName', name);
		frm.submit();
	}
	
	options.removePresetOnClick = function()
	{
		var frm = document.forms['options'];
		var selected = frm.presets.value;
		if (selected == '')
		{
			Forms.showNotification('btnRemovePreset', 'Built-in presets can\'t be removed');
			return;
		}
		if (selected != '---')
		{
			if (confirm('Remove preset: \'' + selected + '\'? This can\'t be undone.'))
			{
				location.href = 'index.jsp?ID='+App.getSessionId()+'&cmd=RemovePreset&presetName='+encodeURIComponent(selected);
			}
		}
	}

	options.toggleGroup = function(event)
	{
		var grpId = Data.get(event.currentTarget, 'group-id');
		var grp = Doc.element('grp.'+grpId);
		var grpIcon = Doc.element('grp.'+grpId+'.icon').firstChild;
		var vldId = 1;
		var vld = Doc.element('vld.'+grpId+'.'+vldId);
		if (vld && vld.style.display == 'none')
		{
			grpIcon.src = App.getRoot()+'images/move_down.png';
		}
		else
		{
			grpIcon.src = App.getRoot()+'images/move_right.png';
		}
		while (vld)
		{
			Doc.showHide(vld);
			vldId++;
			vld = Doc.element('vld.'+grpId+'.'+vldId);
		}
	}

	options.setGroupSeverity = function(event)
	{
		var grpId = Data.get(event.currentTarget, 'group-id');
		var selectedSeverity = event.currentTarget.value;
		event.currentTarget.selectedIndex = 0;
		var vldId = 1;
		var vld = Doc.element('select.'+grpId+'.'+vldId);
		while (vld)
		{
			for (var i = 0; i < vld.length; i++)
			{
				if (vld[i].value == selectedSeverity) 
				{
					vld.selectedIndex = i;
					i = vld.length;
				}
			}
			vldId++;
			vld = Doc.element('select.'+grpId+'.'+vldId);
		}
	}

	return options;
}();

Doc.addElementInitializer(Options.initGroup);
Doc.onLoad(Options.initPage);


