/* $Id $
	------------------------------------------------------------------
	Copyright (C) 2012 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
*/

var Progress = function()
{
	
	var progress = {};

	progress.initPage = function()
	{
		// Dialog buttons
		Buttons.addClickHandler('close', App.closeWindow);
		
		var percentDone = Data.int(document.body, 'percent-done');
		var isError = Data.int(document.body, 'is-error');
		if (!isError)
		{
			setTimeout(percentDone < 100 ? progress.reload : progress.closeWindow, 1500);
		}
		else
		{
			Doc.addClass('progress-bar', 'failed');
			Doc.hide('info');
		}
	}
	
	progress.reload = function()
	{
		location.reload();
	}
	
	progress.closeWindow = function()
	{
		var notifyOpener = Data.get('page-data', 'notify-opener');
		if (notifyOpener)
		{
			try
			{
				var notifyTarget = window.top.opener.document.getElementById(notifyOpener);
				if (notifyTarget)
				{
					var evt = document.createEvent('Event');
					evt.initEvent('base-notify', false, true);
					notifyTarget.dispatchEvent(evt);
				}
			}
			catch (err)
			{}
		}

		App.closeWindow();
	}
	
	return progress;
}();

Doc.onLoad(Progress.initPage);


