<%-- $Id$
	------------------------------------------------------------------
	Copyright (C) 2015 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemList"
	import="net.sf.basedb.core.SyncFilter"
	import="net.sf.basedb.core.SyncFilter.SourceItemTransform"
	import="net.sf.basedb.core.PropertyFilter"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.util.formatter.PropertyFilterFormatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Collections"
	import="java.util.Collection"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.ITEMLIST;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String tab = Values.getStringOrNull(request.getParameter("tab"));
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	ItemList list = ItemList.getById(dc, itemId);
	boolean listIsInSync = true;
	
	final boolean createPermission = sc.hasPermission(Permission.CREATE, itemType);
	final boolean writePermission = list.hasPermission(Permission.WRITE);
	final boolean deletePermission = list.hasPermission(Permission.DELETE);
	final boolean sharePermission = list.hasPermission(Permission.SET_PERMISSION);
	final boolean usePermission = list.hasPermission(Permission.USE);
	final boolean setOwnerPermission = list.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = list.isRemoved();
	final boolean isUsed = isRemoved && list.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = list.isOwner();
	Formatter<Date> timeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, list);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	
	ItemQuery<SyncFilter> sfQuery = list.getSyncFilters();
	List<SyncFilter> syncFilters = new ArrayList<SyncFilter>(sfQuery.list(dc));
	Collections.sort(syncFilters, SyncFilter.compareByChainOrder());
	%>
	<base:page title="<%=title%>" id="view-page">
	<base:head scripts="table.js,tabcontrol-2.js,~lists.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<style>
		.not-in-sync
		{
			text-decoration: line-through;
			display: inline-block;
		}
		</style>
	</base:head>
	<base:body>
		<p:path><p:pathelement 
			title="Item lists" href="<%="index.jsp?ID="+ID%>" 
			/><p:pathelement title="<%=HTML.encodeTags(list.getName())%>"
			/></p:path>
		<div id="page-data" data-item-id="<%=itemId%>"></div>
		
		<t:tabcontrol 
			id="main" 
			subclass="content mastertabcontrol"
			active="<%=tab%>">
		<t:tab id="properties" title="Properties">
			<div>
			<table class="fullform bottomborder">
			<tr>
				<th class="itemstatus">
					<base:icon 
						image="shared.png" 
						visible="<%=list.isShared()%>"
						tooltip="This item is shared to other users, groups and/or projects"
					/>
					<base:icon 
						id="btnDeletePermanently"
						image="deleted.png"
						tooltip="This item has been flagged for deletion. Click to delete it now."
						enabled="<%=deletePermanentlyPermission %>"
						visible="<%=isRemoved%>" 
					/>
					<base:icon 
						id="btnUsingItems"
						image="used.png" 
						tooltip="This item is used by other items and can't be permanently deleted. Show the items that are using this one"
						visible="<%=isRemoved && isUsed%>" />
				</th>
				<td style="padding: 0px;">
					<tbl:toolbar subclass="bottomborder bg-filled-50">
						<tbl:button 
							id="btnEdit"
							disabled="<%=!writePermission%>" 
							image="edit.png" 
							title="Edit&hellip;" 
							tooltip="<%=writePermission ? "Edit this list" : "You do not have permission to edit this list"%>" 
						/>
						<tbl:button 
							id="btnDelete"
							disabled="<%=!deletePermission%>" 
							image="delete.png" 
							title="Delete"
							visible="<%=!list.isRemoved()%>"
							tooltip="<%=deletePermission ? "Delete this list" : "You do not have permission to delete this list"%>" 
						/>
						<tbl:button 
							id="btnRestore"
							disabled="<%=!writePermission%>" 
							image="restore.png" 
							title="Restore"
							visible="<%=list.isRemoved()%>"
							tooltip="<%=writePermission ? "Restore this list" : "You do not have permission to restore this list"%>" 
						/>
						<tbl:button 
							id="btnShare"
							disabled="<%=!sharePermission%>"
							image="share.png"
							title="Share&hellip;" 
							tooltip="<%=sharePermission ? "Share this list to other user, groups and projects" : "You do not have permission to share this list"%>"
						/>
						<tbl:button 
							id="btnSetOwner"
							disabled="<%=!setOwnerPermission%>"
							image="take_ownership.png"
							title="Set owner&hellip;"
							tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
						/>
						<tbl:button
							id="btnCopy"
							image="copy.png"
							tooltip="Create a new list using this as a template"
							subclass="auto-init"
							data-auto-init="clone"
							data-item-id="<%=itemId %>"
							visible="<%=createPermission%>"
							title="Copy&hellip;"
						/>
						<tbl:button
							id="btnMergeUnion"
							data-merge-type="union"
							visible="<%=writePermission && !list.getDisableManualMembers()%>"
							image="set_operations/union_small.png"
							title="Union&hellip;"
							tooltip="Add items from other lists to this list"
						/>
						<tbl:button
							id="btnMergeIntersection"
							data-merge-type="intersection"
							visible="<%=writePermission && !list.getDisableManualMembers()%>"
							image="set_operations/intersection_small.png"
							title="Intersection&hellip;"
							tooltip="Keep only items that are present in other lists"
						/>
						<tbl:button
							id="btnMergeComplement"
							data-merge-type="complement"
							visible="<%=writePermission && !list.getDisableManualMembers()%>"
							image="set_operations/complement_small.png"
							title="Complement&hellip;"
							tooltip="Remove items found in other lists from this list"
						/>
						<tbl:button 
							id="btnImport"
							image="import.png" 
							data-plugin-type="IMPORT"  
							title="Import&hellip;" 
							tooltip="Import data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
						/>
						<tbl:button 
							id="btnExport"
							image="export.png"
							data-plugin-type="EXPORT" 
							title="Export&hellip;" 
							tooltip="Export data" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
						/>
						<tbl:button 
							id="btnRunPlugin"
							image="runplugin.png"  
							data-plugin-type="OTHER" 
							title="Run plugin&hellip;" 
							tooltip="Run a plugin" 
							visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
						/>
						<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
							wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
						<tbl:button
							image="help.png"
							subclass="auto-init"
							data-auto-init="help"
							data-help-id="itemlist.view.properties"
							title="Help&hellip;"
							tooltip="Get help about this page"
						/>	
					</tbl:toolbar>
				</td>
			</tr>
			<tr>
				<th>Name</th>
				<td><%=HTML.encodeTags(list.getName())%></td>
			</tr>
			<tr>
				<th>Member type</th>
				<td><%=list.getMemberType()%>
					<%
					if (list.getMemberType() != Item.RAWBIOASSAY)
					{
						%>
						(<base:propertyvalue item="<%=list%>" property="itemSubtype" nulltext="<i>any</i>"/>)
						<%
					}
					else
					{
						RawDataType rdt = list.getRawDataType();
						%>
						(<%=rdt != null ? HTML.encodeTags(rdt.getName()) : "<i>any</i>"%>)
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<th>Size</th>
				<td><%=list.getSize()%></td>
			</tr>
			<tr>
				<th>Modify members</th>
				<td></td>
			</tr>
			<tr>
				<th class="subprompt">Manual</th>
				<td><%=list.getDisableManualMembers() ? "Disabled" : "Allowed" %></td>
			</tr>
			<tr>
				<th class="subprompt">Sync filters</th>
				<td><%=list.getDisableSyncFilters() ? "Disabled" : "Allowed" %></td>
			</tr>
			<tr>
				<th>Last sync</th>
				<td>
					<%=list.getSyncDate() == null ? "<i>never</i>" : timeFormatter.format(list.getSyncDate())%>
					<span id="not-insync-warning" style="display: none;">
						<i><base:icon image="warning.png" /> List appears to be out of sync with filters</i>
					</span>
					<span id="insync-info" style="display: none;">
						<i><base:icon image="ok.png" /> List appears to be in sync with filters</i>
					</span>
				</td>
			</tr>
			<tr>
				<th>External ID</th>
				<td><%=HTML.encodeTags(list.getExternalId())%></td>
			</tr>
			<tr>
				<th>Owner</th>
				<td><base:propertyvalue item="<%=list%>" property="owner"/></td>
			</tr>
			<tr>
				<th>Permissions</th>
				<td><%=PermissionUtil.getFullPermissionNames(list)%></td>
			</tr>
			<tr>
				<th>Description</th>
				<td><%=HTML.niceFormat(list.getDescription())%></td>
			</tr>
			</table>
			</div>
			
			<base:section 
				id="syncFilters" 
				title="<%="Synchronization filters (" + syncFilters.size() +")"%>"
				context="<%=cc%>"
				>
				<tbl:table
					id="tbl.syncFilters"
					columns="all"
					item="SYNCFILTER"
					action="syncfilter/index.jsp"
					>
					<tbl:hidden name="list_id" value="<%=Integer.toString(itemId) %>" />
					<tbl:columndef 
						id="name"
						title="Name"
					/>
					<tbl:columndef
						id="inSync"
						title="In sync/enabled"
					/>
					<tbl:columndef 
						id="sourceItems"
						title="List members"
					/>
					<tbl:columndef 
						id="filter"
						title="Filter"
					/>
					<tbl:columndef 
						id="matching"
						title="Matching items"
					/>
					<tbl:columndef 
						id="description"
						title="Description"
					/>
					<tbl:toolbar subclass="topborder leftborder rightborder bg-filled-50">
						<tbl:button
							id="btnResync"
							image="resync.png"
							disabled="<%=!writePermission || syncFilters.size() == 0 || list.getDisableSyncFilters() %>"
							tooltip="Re-sync the list with all enabled filters"  
							title="Re-sync&hellip;"
						/>
						<tbl:button 
							id="btnAddSyncFilter"
							image="add.png" 
							disabled="<%=!writePermission%>"
							tooltip="<%=writePermission ? "Add new filter" : "You do not have permission to modify the filters"%>"  
							data-extra-url="<%="&list_id="+itemId%>"
							data-item-type="SYNCFILTER"
							title="Add filter&hellip;"
						/>
						<tbl:button
							id="btnRemoveSyncFilter"
							image="delete_permanently.png"
							disabled="<%=!writePermission%>"
							tooltip="<%=writePermission ? "Remove the selected filters" : "You do not have permission to modify the filters"%>"  
							title="Remove&hellip;"
						/>
						<tbl:button
							id="btnEnable"
							image="start.png"
							disabled="<%=!writePermission%>"
							tooltip="<%=writePermission ? "Enable the selected filters" : "You do not have permission to modify the filters"%>"  
							title="Enable"
						/>
						<tbl:button
							id="btnDisable"
							image="pause.png"
							disabled="<%=!writePermission%>"
							tooltip="<%=writePermission ? "Disable the selected filters" : "You do not have permission to modify the filters"%>"  
							title="Disable"
						/>
					</tbl:toolbar>
					<tbl:data>
						<tbl:headers style="<%=syncFilters.size() == 0 ? "display: none;" : "" %>">
							<tbl:headerrow>
							<tbl:header subclass="index" />
							<tbl:header 
								subclass="check"
								><base:icon 
									subclass="link table-check"
									image="check_uncheck.png" 
									tooltip="Toggle all (use CTRL, ALT or SHIFT to check/uncheck)" 
								/></tbl:header>
								<tbl:columnheaders />
							</tbl:headerrow>
						</tbl:headers>
						<tbl:rows>
						<%
						int index = 0;
						Formatter<PropertyFilter> filterFormatter = new PropertyFilterFormatter(dc, dateFormatter);
						for (SyncFilter sf : syncFilters)
						{
							index++;
							String name = HTML.encodeTags(sf.getName());
							int filterId = sf.getId();
							SourceItemTransform transform = sf.getSourceItemTransformation();
							
							StringBuilder sb = new StringBuilder();
							for (int filterRow = 0; filterRow < sf.getFilterRows(); filterRow++)
							{
								sb.append(filterRow > 0 ? "\nOR " : "");
								List<String> filters = SyncFilter.getFormattedAndSortedFilters(sf.getPropertyFilters(filterRow), filterFormatter);
								sb.append(Values.getString(filters, "\n   AND ", true));
							}
							boolean disabled = sf.isDisabled();
							boolean inSync = !disabled && sf.isInSync(dc);
							if (!disabled) listIsInSync &= inSync;
							int lastSyncMatchingSource = sf.getLastSyncMatchingSource();
							int lastSyncMatchingTransformed = sf.getLastSyncMatchingTransformed();
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									><input 
										type="checkbox" 
										name="<%=filterId%>" 
										value="<%=filterId%>" 
										title="<%=name%>"
									></tbl:header>
								<tbl:cell column="name"><div
									class="<%=writePermission ? "link table-item" : ""%>"
									data-item-id="<%=filterId%>"
									data-no-edit="<%=writePermission ? 0 : 1 %>" 
									data-extra-url="&list_id=<%=itemId%>"
									tabindex="0"
									title=""><%=name%></div></tbl:cell>
								<tbl:cell column="sourceItems">
									<%
									if (transform == SourceItemTransform.NONE)
									{
										%>
										<i><%=sf.getSourceItemType().toString() %></i> must match filter
										<%
									}
									else
									{
										%>
										<%=transform == SourceItemTransform.PARENT_TO_CHILD ? "Parent" : "Child" %>
										<i><%=sf.getSourceItemType().toString() %></i>
										that matches filter
										<i><%=sf.getSourceItemMustExist() ? "must exist" : "must not exist" %></i>
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="filter">
									<base:icon 
											subclass="link auto-init"
											data-auto-init="sync-filter-view"
											data-syncfilter-id="<%=filterId%>" 
											data-source-item-type="<%=sf.getSourceItemType().name()%>"
											image="table_go.png" 
											tooltip="Go to list view with this filter enabled" 
											style="float: right; margin-left: 4px;"
										/>
									<%
									if (writePermission)
									{
										%>
										<base:icon 
											subclass="link auto-init"
											data-auto-init="sync-filter-edit"
											data-syncfilter-id="<%=filterId%>" 
											data-source-item-type="<%=sf.getSourceItemType().name()%>"
											image="edit.png" 
											tooltip="Modify this filter" 
											style="float: right;"
										/>
										<%
									}
									%>
									<pre id="syncfilter.<%=filterId%>"><%=HTML.encodeTags(sb.toString())%></pre></tbl:cell>
								<tbl:cell column="inSync">
									<base:icon 
										image="<%=disabled ? "pause.png" : (inSync ? "ok.png" : "warning.png")%>" style="padding-right: 4px;"
										subclass="<%=disabled ? "interactable disabled" : "" %>"
									/><%=disabled ? "Disabled" : (inSync ? (transform == SourceItemTransform.NONE ? "Yes" : "Yes¹") : "No")%>
								</tbl:cell>
								<tbl:cell column="matching">
									<span class="<%=!inSync ? "not-in-sync" : "" %>">
										<%=lastSyncMatchingSource == -1 ? "?" : lastSyncMatchingSource%>
										<span class="itemsubtype">(<%=sf.getSourceItemType() %>)</span>
										<%
										if (transform != SourceItemTransform.NONE)
										{
											%>
											› <%=lastSyncMatchingTransformed == -1 ? "?" : lastSyncMatchingTransformed%>
											<span class="itemsubtype">(<%=list.getMemberType() %>)</span>
											<%
										}
										%>
									</span>
									<%
									if (!inSync && !disabled)
									{
										%>
										(<%=sf.getCurrentMatchingSource(dc)%> › ?)
										<%
									}
									%>
								</tbl:cell>
								<tbl:cell column="description"><%=HTML.niceFormat(sf.getDescription())%></tbl:cell>
							</tbl:row>
							<%
						}
						if (index == 0)
						{
							%>
							<tbl:panel>
								There are no synchronization filters for this list.
							</tbl:panel>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
				</tbl:table>
				<%
				if (syncFilters.size() > 0)
				{
					%>
					¹ Changes in parent/child relationship are not checked!
					<%
				}
				%>
				<div id="sync-data" class="datacontainer"
					data-is-in-sync="<%=listIsInSync ?  1 : 0%>"
					data-sync-disabled="<%=list.getDisableSyncFilters() ? 1 : 0 %>"
					data-num-syncfilters="<%=syncFilters.size()%>"
				></div>
			</base:section>

			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this list" />
			</jsp:include>
			<jsp:include page="../../common/share/list_share.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Shared to" />
			</jsp:include>
		</t:tab>
		<t:tab id="annotations" title="Annotations" 
			tooltip="View annotation values" clazz="white">
			<jsp:include page="../../common/annotations/list_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		<t:tab id="members" title="Members" />
		<t:tab id="overview" title="Overview" 
			tooltip="Display a tree overview of related items"
			visible="<%=list.getMemberType() != Item.FILE%>">
			<jsp:include page="../../common/overview/overview.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>			
		<t:tab id="history" title="Change history" 
			tooltip="Displays a log of all modifications made to this item"
			visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
			<jsp:include page="../../common/history/frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>			
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
